
#ifndef PROCESS_H
#define PROCESS_H

#include <stdio.h>
#include <stdlib.h>

class Process
{
	int argsNum, envsNum;
	char *args[256];
	char *envs[10];
	pid_t pid;
	int result;
	int outPipe[2], inPipe[2], errPipe[2];
	FILE *inStream, *protoStream;
	int linePos;
	char lineStr[1024];
public:
	Process(const char *fileName, const char *protoName = NULL);
	~Process();
	void addArg(const char *argStr);
	void closePipeToChild();
	int getResult();
	int read(char *buf, int count);
	virtual const char *readLine();
	int run();
	void select();
	void show();
	void start(const char *workDirName = NULL, int splitOut = 0);
	void terminate();
	const char *toString(char *str);
	int write(const char *buf, int count);

private:
	void closePipes();
};

#endif

