
#include <errno.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>

#include "Support.h"

void skipBytes(FILE *inStream, int bytesToSkip)
{
	while (bytesToSkip > 0)
	{
		char buf[16*1024];
		int n = fread(buf, 1,
			min(bytesToSkip, sizeof buf), inStream);
		if (feof(inStream))
			break;
		bytesToSkip -= n;
	}
}

void
makeDirs(const char *fileName)
{
	char str[1024];
	int i = 0;
	while (1)
	{
		for (; fileName[i] != 0 && fileName[i] != '/'; i++)
			str[i] = fileName[i];
		str[i] = 0;

		if (fileName[i] == 0)
			break;

		mkdir(str, S_IRWXU);
		str[i++] = '/';
	}
}

int
waitForInput(FILE *inStream, int seconds)
{
	fd_set fdSet;
	FD_ZERO(&fdSet);
	FD_SET(fileno(inStream), &fdSet);

	struct timeval timeout;
	timeout.tv_sec = seconds;
	timeout.tv_usec = 0;

	int res;
	do {
 		res = select(FD_SETSIZE, &fdSet, NULL, NULL, &timeout);
	} while (res == -1L && errno == EINTR);

	return res;
}

