
// webInstall - Installing webCDwriter by Netscape Communicator
// Author: Jrg Haeger, 07.10.2000

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import netscape.security.PrivilegeManager;


public class webInstall extends Applet
	implements java.awt.event.ActionListener
{
	final public static String
//		feedbackAddress = "dummy1@localhost",
		feedbackAddress = "cdwriter@asterix.hrz.uni-bielefeld.de",
		product = "webCDwriter",
		server = "www.uni-bielefeld.de",
		serverDir = "~jhaeger/webCDwriter/download",
		version = "1.0pre6",
		webInstallVersion = "20001025";

	final public static String
		back = "<< Back",
		feedback = "Feedback",
		next = "Continue >>",
		ok = "OK",
		send = "Send";

	String webCDwriterSignedURL = "http://" + server + "/"
		+ serverDir + "/" + product + "-" + version
		+ "-signed.tgz";
//	String webCDwriterSignedURL
//		= "http://localhost/webCDwriter-work-signed.tgz";

	static String
		archive,
		cdrecord,
		busIdLUN,
		baseDir = "",
		homeDir,
		hostname = "localhost",
		mkisofs,
		mkisofsMArg,
		srcDir,
		systemInfo;

	Script s;
	int state = 0;
	static TextArea textArea = new TextArea();
	TextArea infoArea;
	Button b1, b2, fb;
	TextField textField;
	List list;

	public void actionPerformed(java.awt.event.ActionEvent e)
	{
		b1.setEnabled(false);
		b2.setEnabled(false);
		fb.setEnabled(false);

		if (e.getActionCommand().equals(back))
		{
			if (fb.getLabel().equals(send))
			{
				fb.setLabel(feedback);
				state--;
			}
			else
				state -= 2;
		}

		if (e.getActionCommand().equals(feedback))
		{
			show(
"You can participate in the development of webInstall by sending me"
+ " a feedback. You can add your comment or description of a problem"
+ " to the above log. Please also add the contents of the"
+ " Communicator - Tools - Java Console.\n"
+ "Pressing the send button will send the contents"
+ " of the log to " + feedbackAddress + ".");
			fb.setLabel(send);
			fb.setEnabled(true);
			return;
		}

		if (e.getActionCommand().equals(send))
		{
			show("Sending your feedback...");
			mailLog();
			show("Thank you for your feedback.");
			return;
		}

		try {
			PrivilegeManager.enablePrivilege(
				"UniversalFileAccess");
		}
		catch (Exception e2) {
			System.out.println(e2);
		}

		textField.setVisible(false);

		switch (state)
		{
		case 0:
			b1.setVisible(false);
			println("Exploring your system...");
			show("Exploring your system...");
			s = new Script("uname -a");
			s.start();
			systemInfo = s.readLine();
			if (systemInfo == null)
			{
				show("Cannot run uname -a");
				break;
			}
			if (!systemInfo.startsWith("Linux"))
			{
				show("Sorry, currently only Linux is supported.");
				break;
			}
			s.nextToken();
			s.nextToken();
			hostname = s.sval;

			s = new Script("echo $HOME");
			s.start();
			homeDir = s.readLine();
			if (homeDir == null)
				baseDir = "/opt";
			else
				baseDir = homeDir + "/webCDwriter/";

			if (!new File("/etc/rc.d/init.d/").exists())
				println("/etc/rc.d/init.d/ does not exist");

			s = new Script("type -path cdrecord");
			s.start();
			cdrecord = s.readLine();
			if (cdrecord == null)
			{
				show("Cannot find cdrecord. Make sure it is\n"
					+ "installed and in your PATH.");
				break;
			}

			s = new Script("type -path mkisofs");
			s.start();
			mkisofs = s.readLine();
			if (mkisofs == null)
			{
				show("Cannot find mkisofs. Make sure it is\n"
					+ "installed and in your PATH.");
				break;
			}

			// println("Getting the version of cdrecord");
			s = new Script(cdrecord + " -version");
			s.start();
			if (s.readLine() == null)
			{
				show("Cannot run " + cdrecord);
				break;
			}

			// println("Getting the version of mkisofs");
			s = new Script(mkisofs + " -version");
			s.start();
			if (s.readLine() == null)
			{
				show("Cannot run " + mkisofs + " -version.\n"
				+ "Make sure you have 1.13 or above installed!");
				break;
			}

			// println("Looking for the CD writer");
			list.removeAll();
			s = new Script(cdrecord + " -scanbus");
			s.start();
			String str;
			while ((str = s.readLine()) != null)
				if (str.indexOf("CD-ROM") >= 0
					|| str.indexOf("WORM") >= 0)
				{
					String str2 = parseBusIdLUN();
					if (str2 != null)
						list.add(str2);
				}

			if (list.getItemCount() == 0)
			{
				println("ls -l " + cdrecord);
				show("Cannot find any CD-writer.\n"
				+ "Make sure your hardware is installed correctly"
				+ " and cdrecord has the s bit set.\n"
				+ "If not, run chmod +s " + cdrecord + " as root.");
				break;
			}

			println("Your system seems to be OK.");

			show("Enter the base directory of the installation:");
			textField.setText(baseDir);
			textField.setVisible(true);
			state++;
			b1.setVisible(true);
			break;

		case 1:
			baseDir = textField.getText();
			if (!baseDir.endsWith("/"))
				baseDir = baseDir + "/";
			archive = baseDir + product + "-" + version
				+ "-signed.tgz";
			srcDir = baseDir + product + "-" + version + "/";

			show("Making directories");
			println("\nMaking directories");
			try {
				makeDir("");
				makeDir("bin");
				makeDir("conf");
				makeDir("log");
				makeDir("spool");
				makeDir("www");
			} catch (Exception e4)
			{
				break;
			}

			list.setVisible(true);
			show("Select the CD writer!");
			state++;
			break;

		case 2:
			busIdLUN = list.getSelectedItem();
			if (busIdLUN == null)
				break;
			mkisofsMArg = "/dev/scd" + list.getSelectedIndex();
			list.setVisible(false);

/*			println("Ejecting the tray...");
			runScript("cdrecord dev=" + busIdLUN + " -eject");
			show("Is the tray ejected? If not, go back.");

			runScript("cdrecord dev=" + busIdLUN + " -load");
*/
			runScript("ls -l " + mkisofsMArg);
			if (!new File(mkisofsMArg).canRead())
			{
				show("Cannot read " + mkisofsMArg + ".\n"
				+ "Try to run (as root)\n"
				+ "chown "
				+ System.getProperty("user.name")
				+ " " + mkisofsMArg);
				break;
			}

			if (!new File(archive).exists())
			{
				println("\nDownloading " + webCDwriterSignedURL + "...");
				show("Downloading " + webCDwriterSignedURL + " (2 MB)");
				download();
			}

			if (!new File(archive).exists())
			{
				println("Could not download " + webCDwriterSignedURL);
				show("Could not download " + webCDwriterSignedURL);
				break;
			}

			show("Unpacking webCDwriter...");
			println("\nUnpacking webCDwriter...");
			Script s = new Script("cd " + baseDir);
			s.add("tar xzvf " + archive);
			s.run();

			show("Compiling CDWserver...");
			println("\nCompiling CDWserver...");
			s = new Script("cd " + srcDir + "CDWserver/");
			s.add("make");
			s.add("make clean");
			s.run();

			show("Installing CDWserver...");
			println("\nInstalling CDWserver...");

			println("Writing config...");
			writeConfig();

			// CDWserver/control -> bin/CDWserver
			StreamEditor sed = new StreamEditor();
			sed.addSubstitute("/var/run/CDWserver.pid",
				baseDir + "log/CDWserver.pid");
			sed.addSubstitute("/usr/local/sbin/CDWserver",
				baseDir + "webCDwriter/CDWserver/CDWserver");
			sed.addSubstitute("/etc/CDWserver/config",
				baseDir + "conf/config");
			sed.run(srcDir + "CDWserver/control",
				baseDir + "bin/CDWserver");

			new File(baseDir + "webCDwriter").delete();
			s = new Script("cd " + baseDir);
			s.add("chmod +x bin/CDWserver");
			s.add("ln -s ../webCDwriter/webCDcreator/4netscape www/4netscape");
			s.add("ln -s ../webCDwriter/webCDcreator/4plugin www/4plugin");
			s.add("ln -s webCDwriter-" + version + " webCDwriter");
			s.run();

			s = new Script(
				"cd " + srcDir + "webCDcreator/4netscape/");
			s.add("make");
			s.run();

			s = new Script(
				"cd " + srcDir + "webCDcreator/4plugin/");
			s.add("make");
			s.run();
			show(
"The applet webCDcreator will be exported by your local webserver."
+ " Therefore the installation directory and its ancestors have to be"
+ " readable by all users.\n"
+ "I have to run\n"
+ "chmod o+rx " + homeDir + "\n"
+ "chmod o+r -R " + baseDir);
			state++;
			break;

		case 3:
			runScript("chmod o+rx " + homeDir);
			runScript("chmod o+r -R " + baseDir);
			runScript(baseDir + "bin/CDWserver restart");

			try {
			println("Trying to open the CDWserver status page...");
			getAppletContext().showDocument(
				new URL("http://" + hostname + ":10001"),
				"_blank");
			} catch (Exception e5) {}
			show("Now go to the root directory of your webserver\n"
				+ "(e.g. /var/www/html/) and execute\n"
				+ "ln -s " + baseDir + "www webCDcreator");
			state++;
			break;

		case 4:
			println("Trying to start webCDcreator for Netscape...");
			try {
			getAppletContext().showDocument(
				new URL("http://" + hostname
					+ "/webCDcreator/4netscape/"),
				"_blank");
			} catch (Exception e6) {}
			show(
"Congratulations! webCDwriter was installed successfully."
+ " CDWserver is already running and waiting for connections."
+ " If you want to start CDWserver by the init process"
+ " at system startup, execute as root\n"
+ "cp " + baseDir + "bin/CDWserver /etc/rc.d/init.d/\n"
+ "and create links in the /etc/rc.d/rc?.d/ directories.");
			state++;
			break;

		default:
				runScript("xterm -sb");
			break;
		}

		fb.setEnabled(true);
		if (state < 5)
		{
			b1.setEnabled(true);
			b2.setEnabled(true);
		}
	}

	void download()
	{
		try {
		PrivilegeManager.enablePrivilege(
			"UniversalFileWrite");

		InputStream inStream = new URL(webCDwriterSignedURL)
			.openStream();
		FileOutputStream outStream
			= new FileOutputStream(archive);
		while (true)
		{
			byte bs[] = new byte[1024];
			int n = inStream.read(bs);
			if (n < 0)
				break;
			outStream.write(bs, 0, n);
		}
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}

	static String getSed(String str, String by)
	{
		return "sed s/" + getSedStr(str)
			+ "/" + getSedStr(by) + "/g ";
	}

	static String getSedStr(String str)
	{
		byte[] bs = str.getBytes();
		byte[] rs = new byte[1024];
		int i, j;
		for (i = 0, j = 0; i < bs.length; i++)
			if (bs[i] == '/')
			{
				rs[j++] = (byte)'[';
				rs[j++] = bs[i];
				rs[j++] = (byte)']';
			}
			else
				rs[j++] = bs[i];

		return new String(rs, 0, j);
	}

	public void init()
	{
		setLayout(LM);
//		textArea = new TextArea();
		add(textArea);
		println("webInstall " + webInstallVersion);

		infoArea = new TextArea(
"Welcome to webInstall\n"
+ "webInstall will install the webCDwriter on your Linux machine.\n"
+ "It will need the permission to write files\n"
+ "and run programs on your computer.\n"
+ "It is recommended to create a special user on your system,\n"
+ "change to this user and return to this page.",
			60, 10, TextArea.SCROLLBARS_NONE);
		infoArea.setEditable(false);
		add(infoArea);

		b1 = new Button(back);
		b1.addActionListener(this);
		b1.setVisible(false);
		add(b1);

		b2 = new Button(next);
		b2.addActionListener(this);
		add(b2);

		fb = new Button(feedback);
		fb.addActionListener(this);
		b1.setEnabled(false);
		add(fb);

		textField = new TextField("", 40);
		textField.setVisible(false);
		add(textField);

		list = new List();
		list.setVisible(false);
		add(list);
	}

	void mailLog()
	{
		try {
		PrivilegeManager.enablePrivilege(
			"UniversalFileWrite");

		PrintWriter outStream
			= new PrintWriter(
				new FileOutputStream(
					"/tmp/webInstall.log"));
		outStream.println(textArea.getText());
//		runScript("cat /tmp/webInstall.log"
//			+ " | mail -s Feedback " + feedbackAddress);
		outStream.close();

		s = new Script("mail -s Feedback " + feedbackAddress);
		s.start();
		s.write(textArea.getText());
		while (s.readLine() != null) ;
		} catch (Exception e)
		{
			println(e.toString());
		}
	}

	void makeDir(String name) throws Exception
	{
		File dir = new File(baseDir + name);
		if (!dir.isDirectory())
			if (dir.mkdirs())
				println(dir.toString() + " created");
			else
			{
				println("Cannot make directory " + dir);
				throw new Exception();
			}
	}

	String parseBusIdLUN()
	{
		s.getTokenizer().wordChars(',', ',');
		String str = "";
		if (s.nextToken() != StreamTokenizer.TT_NUMBER)
			return null;
		str += (int)s.nval;

		if (s.nextToken() != StreamTokenizer.TT_WORD)
			return null;
		str += s.sval;

		return str;
	}

	void println(String str)
	{
		textArea.append(str + "\n");
	}

	void runScript(String script)
	{
		System.out.println("runScript()");
		Script s = new Script(script);
		s.run();
	}

	void show(String str)
	{
		infoArea.setText(str);
	}

	public void start()
	{
		System.out.println("Start");
	}

	public void writeConfig()
	{
		// CDWserver/config.eg -> conf/config
		StreamEditor sed = new StreamEditor();
		sed.addSubstitute("cdrecordDevArg=auto",
			"cdrecordDevArg=" + busIdLUN);
		sed.addSubstitute("=cdrecord", "=" + cdrecord);
		sed.addSubstitute("=root",
			"=" + System.getProperty("user.name"));
		sed.addSubstitute("/var/log/CDWserver",
			baseDir + "log");
		sed.addSubstitute("=mkisofs", "=" + mkisofs);
		sed.addSubstitute("mkisofsMArg=auto",
			"mkisofsMArg=" + mkisofsMArg);
		sed.addSubstitute("/var/spool/CDWserver",
			baseDir + "spool");
		sed.run(srcDir + "CDWserver/config.eg",
			baseDir + "conf/config");
	}

	LayoutManager LM = new LayoutManager()
	{
		public void addLayoutComponent(String name, Component comp)
		{
			System.out.println("addLayoutComponent: " + name);
		}

		public void layoutContainer(Container parent)
		{
			Dimension d = parent.getSize();
			int x = d.width;
			int y = d.height;
			parent.getComponent(0).setBounds(
				0, 0, x, y - 150);
			parent.getComponent(1).setBounds(
				0, y - 140, x - 200, 90);
			parent.getComponent(2).setBounds(
				x - 100, y - 90, 90, 30);
			parent.getComponent(3).setBounds(
				x - 100, y - 40, 90, 30);
			parent.getComponent(4).setBounds(
				x - 100, y - 140, 90, 30);
			parent.getComponent(5).setBounds(
				0, y - 40, x - 80 - 20 - 20 - 80, 30);
			parent.getComponent(6).setBounds(
				x - 190, y - 140, 80, 130);
		}

		public Dimension minimumLayoutSize(Container parent)
		{
			return new Dimension(100, 100);
		}

		public Dimension preferredLayoutSize(Container parent)
		{
			return new Dimension(400, 400);
		}

		public void removeLayoutComponent(Component comp)
		{
		}
	};
}


class Script
{
	static int no = 0;
	String text = "", lastLine = "";
	BufferedReader br;
	InputStream errorIn;
	PrintWriter bw;
	StreamTokenizer tokenizer;
	double nval;
	String sval;

	Script(String command)
	{
		no++;
		add(command);
	}

	void add(String command)
	{
		text = text
			+ "echo '> " + command + "'\n"
			+ command + "\n";
	}

	StreamTokenizer getTokenizer()
	{
		if (tokenizer == null)
			tokenizer = new StreamTokenizer(
				new StringReader(lastLine));
		return tokenizer;
	}

	int nextToken()
	{
		getTokenizer();
		int r;
		try {
			r = tokenizer.nextToken();
		}
		catch (IOException e)
		{
			r = 0;
		}
		nval = tokenizer.nval;
		sval = tokenizer.sval;
		return r;
	}

	String readLine()
	{
		try {
			byte bs[] = new byte[1024];
			int n = errorIn.read(bs, 0, errorIn.available());
			if (n > 0 && bs[n - 1] == 10)
				n--;
			if (n > 0 && bs[n - 1] == 13)
				n--;
			if (n > 0)
				webInstall.textArea.append("error <"
					+ new String(bs, 0, n) + ">\n");
			lastLine = br.readLine();
			if (lastLine.equals("endOfScript"))
				return  null;
			else
			{
				webInstall.textArea.append(lastLine + "\n");
				tokenizer = null;
				return lastLine;
			}
		}
		catch (IOException e)
		{
			return null;
		}
	}

	void run()
	{
		start();
		while (readLine() != null)
			;
	}

	void start()
	{
//		webInstall.textArea.append("Running\n");
//		webInstall.textArea.append(text);
		Runtime r = Runtime.getRuntime();
		Process p;
		try {
			PrivilegeManager.enablePrivilege(
				"UniversalFileWrite");

			String str = String.valueOf(no);
			if (str.length() < 2)
				str = "0" + str;
			str = "/tmp/install." + str + ".sh";
			PrintWriter outStream
				= new PrintWriter(
					new FileOutputStream(str));
			outStream.print(text);
			outStream.println("echo endOfScript");
			outStream.close();

			PrivilegeManager.enablePrivilege(
				"UniversalExecAccess");
			p = r.exec("/bin/sh " + str);
		}
		catch (Exception e) {
			System.out.println(e);
			return;
		}

		br = new BufferedReader(
			new InputStreamReader(
				p.getInputStream()));
		errorIn = p.getErrorStream();
		readLine();

		bw = new PrintWriter(p.getOutputStream());
	}

	void write(String str) throws IOException
	{
		bw.println(str);
		bw.close();
	}
}

class StreamEditor
{
	String strs[] = new String[100];
	String bys[] = new String[100];
	int numOfRules = 0;

	void addSubstitute(String str, String by)
	{
		strs[numOfRules] = str;
		bys[numOfRules] = by;
		numOfRules++;
	}

	void run(String inName, String outName)
	{
		System.out.println(inName + " -> " + outName);
		try {
			BufferedReader inStream
				= new BufferedReader(
					new InputStreamReader(
					new FileInputStream(inName)));
			PrintWriter outStream
				= new PrintWriter(
					new FileOutputStream(outName));

			while (true)
			{
				String str = inStream.readLine();
				if (str == null)
					break;
				int count = 0;
				for (int i = 0; i < numOfRules; i++)
				{
					int p = str.indexOf(strs[i]);
					if (p >= 0)
					{
						str = str.substring(0, p)
						+ bys[i] + str.substring(p + strs[i].length());
						if (count++ < 100)
							i = -1;
					}
				}
				outStream.println(str);
			}

			outStream.close();
		} catch (IOException e)
		{
			System.out.println(e);
		}
	}
}

